#!/usr/bin/perl

use strict;

my $dir = shift;
my $lib = shift;
my $type = shift;
my $outdir = shift;

my $align = "/home/pubseq/BioSw/blat_64/blat";
my $parse = "python /home/rchiu/trans-abyss/utilities/contig_merger.py";

opendir DIR, $dir;
my @ks = sort {$a cmp $b} (grep /^k\d+$/, readdir DIR);
closedir DIR;

my $round = 1;
my $last_round = 0;
#my $left_round;
my $left = undef;

if (!-d $outdir) {
  print `mkdir $outdir`;
}

if (-d "$outdir/$type") {
  print `rm -Rf $outdir/$type\n`;
}
print `mkdir $outdir/$type\n`;

print "@ks\n";
my %rounds = map {$_=>0} @ks;

my @pairs;
do {
  undef @pairs;
  for (my $i=0; $i<=$#ks; $i+=2) {
    my $j = $i+1;

    if ($j > $#ks) {
      $left = $i;
#      if (!defined $left_round) {
#	$left_round = $last_round;
#      }
#      print "left $i round$left_round\n";
    }
    else {
      push @pairs, [$i,$j];
    }
  }

  #print "round:$round\n";
  my @ks2;
  for my $pair(@pairs) {
    #print "$ks[$pair->[0]] $ks[$pair->[1]]\n";

#    my @fas = $round == 1 ? ("$dir/$ks[$pair->[0]]/$lib-$type.fa", "$dir/$ks[$pair->[1]]/$lib-$type.fa") : ("$outdir/$type/round$last_round/$ks[$pair->[0]].fa", "$outdir/$type/round$last_round/$ks[$pair->[1]].fa");

#    my @fas = $round == 1 ? ("$dir/$ks[$pair->[0]]/$lib-$type.fa", "$dir/$ks[$pair->[1]]/$lib-$type.fa") : ("$outdir/$type/round$rounds{$ks[$pair->[0]]}/$ks[$pair->[0]].fa", "$outdir/$type/round$rounds{$ks[$pair->[1]]}/$ks[$pair->[1]].fa");

    my @fas;
    if ($round == 1) {
      @fas =  ("$dir/$ks[$pair->[0]]/$lib-$type.fa", "$dir/$ks[$pair->[1]]/$lib-$type.fa");
    }
    else {
      if ($rounds{$ks[$pair->[0]]} == 0) {
	$fas[0] = "$dir/$ks[$pair->[0]]/$lib-$type.fa"
      }
      else {
	$fas[0] = "$outdir/$type/round$rounds{$ks[$pair->[0]]}/$ks[$pair->[0]].fa";
      }

      if ($rounds{$ks[$pair->[1]]} == 0) {
	$fas[1] = "$dir/$ks[$pair->[1]]/$lib-$type.fa"
      }
      else {
	$fas[1] = "$outdir/$type/round$rounds{$ks[$pair->[1]]}/$ks[$pair->[1]].fa";
      }
    }


    align($ks[$pair->[0]], $ks[$pair->[1]], @fas, "$outdir/$type/round$round");

    my @new_k;
    if ($ks[$pair->[0]] =~ /-/) {
      push @new_k, (split '-', $ks[$pair->[0]])[0];
    }
    else {
      push @new_k, $ks[$pair->[0]];
    }

    if ($ks[$pair->[1]] =~ /-/) {
      push @new_k, (split '-', $ks[$pair->[1]])[1];
    }
    else {
      push @new_k, $ks[$pair->[1]];
    }

    push @ks2, join '-', @new_k;
  }
  if (defined $left) {
    #print "left $left $ks[$left] round$left_round\n";
    push @ks2, $ks[$left];
    undef $left;
  }
  @ks = @ks2;

  for my $k(@ks) {
    $rounds{$k} = $round if !exists $rounds{$k};
  }
  $last_round = $round;
  $round ++;
  print "round:$round @ks\n";

  #print "@pairs\n";
} while ($round == 1 || @ks > 1);

#last round - self vs self
if ($round > 1 && @ks==1) {
  my @fas = ("$outdir/$type/round$last_round/$ks[0].fa", "$outdir/$type/round$last_round/$ks[0].fa");
  align($ks[0], $ks[0], @fas, "$outdir/$type/round$round");
}


sub align {
  my ($k1, $k2, $fa1, $fa2, $out_dir) = @_;

  print "$fa1 $fa2 $out_dir\n";

  my $kout1 = $k1;
  my $first1 = 0;
  if ($k1 =~ /-/) {
    ($kout1) = $k1 =~ /^(k\d+)/;
  }
  else {
    $first1 = 1;
  }

  my $kout2 = $k2;
  my $first2 = 0;
  if ($k2 =~ /-/) {
    ($kout2) = $k2 =~ /-(k\d+)$/;
  }
  else {
    $first2 = 1;
  }

  my $first = "";
  if ($first1 && $first2) {
    $first = "-1 b";
  }
  elsif ($first1) {
    $first = "-1 q";
  }
  elsif ($first1) {
    $first = "-1 t";
  }

  my @cmds;
  if (!-d $out_dir) {
    push @cmds, "mkdir $out_dir";
  }
  push @cmds, "$align $fa2 $fa1 $out_dir/$kout1-$kout2.psl -minIdentity=100 -maxGap=0";
  if ($k1 ne $k2) {
    push @cmds, "$align $fa1 $fa2 $out_dir/$kout2-$kout1.psl -minIdentity=100 -maxGap=0";
    push @cmds, "$parse $fa1 $fa2 $out_dir/$kout1-$kout2.psl blat $out_dir/$kout1-$kout2.fa -r $out_dir/$kout2-$kout1.psl -l $out_dir/$kout1-$kout2.log $first";
  }
  else {
    push @cmds, "$parse $fa1 $fa2 $out_dir/$kout1-$kout2.psl blat $out_dir/$kout1-$kout2.fa -l $out_dir/$kout1-$kout2.log $first";
  }

  for my $cmd(@cmds) {
    print `$cmd\n`;
  }
}
